% Electron mobility for high and low-performing devices for various
% acceptor/[acceptor+donor] compositions. Input variable x is the
% acceptor/[acceptor+donor] composition.
function mob = un(x)

%Good Solvent Devices
comp = [0 0.5 0.7 0.8333 1];
mob_comp = [1.5e-10 6.24e-9 7.24e-9 1.327e-8 2.13e-9];

%Poor solvent devices
% comp = [0 0.5 0.666 0.833 1];
% mob_comp = [7.7e-11 7.66e-10 1.117e-9 1.247e-9  2.13e-9];

% Compute electron mobility for a specified acceptor/[acceptor+donor]
% composition with linear interpolation
if x <= comp(1),
    mb = inv([comp(1) 1; comp(2) 1])*[mob_comp(1); mob_comp(2)];
    mob = (mb(1)*x+mb(2));
end

if x >= comp(end),
    mb = inv([comp(length(comp)-1) 1; comp(length(comp)) 1])*[mob_comp(length(mob_comp)-1); mob_comp(length(mob_comp))];
    mob = (mb(1)*x+mb(2));
end

if (x<comp(end))&&(x>comp(1)),
    u = find(comp>x);
    l = find(comp<x);
    if (u(1)-l(end))>=2,
        mob = mob_comp(u(1)-1);
    else
        mb = inv([comp(l(end)) 1; comp(u(1)) 1])*[mob_comp(l(end)); mob_comp(u(1))];
        mob = (mb(1)*x+mb(2));
    end
end