% Hole mobility for high and low-performing devices for various
% acceptor/[acceptor+donor] compositions. Input variable x is the
% acceptor/[acceptor+donor] composition.
function mob = up(x)

%Good solvent devices
comp = [0 0.5 0.7 0.8333 1];
mob_comp = [7.45e-9 2.787e-8 2.241e-8 1.709e-8 2.623e-8];

%Poor solvent devices
% comp = [0 0.5 0.666 0.833 1];
% mob_comp = [7.45e-9 4.02e-9 4.04e-9 1.021e-8 3.02e-8];

% Compute hole mobility for a specified acceptor/[acceptor+donor]
% composition with linear interpolation
if x <= comp(1),
    mb = inv([comp(1) 1; comp(2) 1])*[mob_comp(1); mob_comp(2)];
    mob = (mb(1)*x+mb(2));
end

if x >= comp(end),
    mb = inv([comp(length(comp)-1) 1; comp(length(comp)) 1])*[mob_comp(length(mob_comp)-1); mob_comp(length(mob_comp))];
    mob = (mb(1)*x+mb(2));
end

if (x<comp(end))&&(x>comp(1)),
    u = find(comp>x);
    l = find(comp<x);
    if (u(1)-l(end))>=2,
        mob = mob_comp(u(1)-1);
    else
        mb = inv([comp(l(end)) 1; comp(u(1)) 1])*[mob_comp(l(end)); mob_comp(u(1))];
        mob = (mb(1)*x+mb(2));
    end
end